/*****************************

Copyright 2002 Jeff Pierce wd4nmq.

This software is covered by the included GNU Public License, GPL.

$Log$

****************************/ 

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <time.h>

#include "forms.h"
#include "testgui.h"
#include "serverglobals.h"

extern char callsign[], name[], location[], password[];

extern *userServer;


struct entry *addEntryList(struct entry *, struct stationData *);
struct entry *flushEntryList(struct entry *);
int printList(struct entry *);

struct stationData  *station;
struct entry        *listHead;

/************************/
/**** Open a socket *****/

int  openSocket(char *srvr_addr){

  int  sck, z;
  struct sockaddr_in adr_srvr;/* AF_INET */
  int len_inet;               /* length  */
  struct hostent *hp;
  char *addr;

  hp = gethostbyname(srvr_addr);

  if(hp){
    addr = inet_ntoa(*(struct in_addr *)hp->h_addr_list[0]);
 
  } else {
    return(-1);
  }
  memset(&adr_srvr,0,sizeof adr_srvr);
  adr_srvr.sin_family = AF_INET;
  adr_srvr.sin_port = htons(5200);
  adr_srvr.sin_addr.s_addr =
    inet_addr(addr);

  if ( adr_srvr.sin_addr.s_addr == INADDR_NONE )
    return(-1);

  len_inet = sizeof adr_srvr;

  /*
   * Create a TDP/IP socket to use :
   */
  sck = socket(PF_INET,SOCK_STREAM,0);
  if ( sck == -1 )
    return(sck);
    
  /*
   * Connect to the server:
   */
 
  z = connect(sck, (struct sockaddr *) &adr_srvr,len_inet);
    if ( z == -1 ){
    close(sck);
    return(-1);
    }

  return(sck);

}

/************************************/

int sendLogon(char *srvr_addr){

  struct tm *tm_ptr;
  time_t    theTime;
  char      logTime[6];
  unsigned char    sendBuf[50], recvBuf[50];
  int     i, s, z, result;

  /* Now send the 'l' command */

  s = openSocket(srvr_addr);
  if(s < 0)
    return(0);
  memset(sendBuf, 0x6c, 1);
  result = write(s, sendBuf, 1);

  /* Get the local time */
  (void) time(&theTime);
  tm_ptr = localtime(&theTime);
  strftime(logTime, 6, "%H:%M", tm_ptr);

  strcpy(sendBuf, callsign);
  strcat(sendBuf,"\254\254");
  strcat(sendBuf, password);
  strcat(sendBuf, "\015ONLINE3.38(");
  strcat(sendBuf, logTime);
  strcat(sendBuf, ")\015");
  strcat(sendBuf,location);
  strcat(sendBuf,"\015");

  result = write(s, sendBuf, strlen(sendBuf));

  result = read(s, recvBuf, 50);
  if(result < 0){
    perror(" Receive ");
    close(s);
    return(0);
  }

  if(strncmp(recvBuf, "OK", 2) != 0){
    close(s);
    return(0);
  }

  close(s);
  return(1);

}

/************************************/

int sendLogoff(char *srvr_addr){

  unsigned char    sendBuf[50], recvBuf[50];
  int     i, s, result;

  s = openSocket(srvr_addr);
  if(s<0)
    return(0);

  /* Now send the 'l' command */
  memset(sendBuf, 0x6c, 1);
  result = write(s, sendBuf, 1);

  strcpy(sendBuf, callsign);
  strcat(sendBuf,"\254\254");
  strcat(sendBuf, password);
  strcat(sendBuf,"\015OFF-V3.40\015");
  strcat(sendBuf, location);
  strcat(sendBuf, "\015");
  for(i=0;i<strlen(sendBuf);i++){
  }

  result = write(s, sendBuf, strlen(sendBuf));

  /* Now get the result */
  result = read(s, recvBuf, 50);
  if(result < 0){
    perror(" Receive ");
    return(0);
  }

  close(s);
  return(1);

}
/************************************/

int makeMeBusy(char *srvr_addr, char *station){

  struct tm *tm_ptr;
  time_t    theTime;
  char      logTime[6];
  unsigned char    sendBuf[50], recvBuf[50];
  int     i, s, result;

  s = openSocket(srvr_addr);
  if(s<0)
    return(0);

  /* Now send the 'l' command */
  memset(sendBuf, 0x6c, 1);
  result = write(s, sendBuf, 1);

  /* Get the local time */
  (void) time(&theTime);
  tm_ptr = localtime(&theTime);
  strftime(logTime, 6, "%H:%M", tm_ptr);

  strcpy(sendBuf, callsign);
  strcat(sendBuf,"\254\254");
  strcat(sendBuf, password);
  strcat(sendBuf,"\015BUSY3.40(");
  strcat(sendBuf, logTime);
  strcat(sendBuf, ")\015");
  if(station == NULL)
    strcat(sendBuf,location);
  else{
    strcat(sendBuf, "In QSO, ");
    strcat(sendBuf, station);
  }
  strcat(sendBuf,"\015");
  for(i=0;i<strlen(sendBuf);i++){
  }

  result = write(s, sendBuf, strlen(sendBuf));

  /* Now get the result */
  result = read(s, recvBuf, 50);
  if(result < 0){
    perror(" Receive ");
    return(0);
  }

  close(s);
  return(1);

}

/************* find end of list **********/

struct entry *findEnd(struct entry *list){

  struct entry *temp;

  if(list == NULL){ 
    return(NULL);
  }

  temp = list;
  while(temp->next != NULL){
    temp = temp->next;
  }

  return(temp);
}

/***** Get calls function **********/

int getCalls(char *srvr_addr){

  int  s, result, i, j, numRecs;
  unsigned char sendBuf[10], recvBuf[2000];
  char *ptr, *eptr, c;
  char temp[4][80];
  FILE *tx, *rx;
  struct entry *last;
  struct entry *entryPtrs[5];
  char line[40];

  for(i=0;i<5;i++)
    entryPtrs[i] = NULL;

  s = openSocket(srvr_addr);

  rx = fdopen(s, "r");
  if(rx ==NULL){
    perror("Openning rx stream");
    close(s);
    return(-1);
  }

  tx = fdopen(dup(s), "w");
  if(tx == NULL){
    perror("Openning tx stream");
    fclose(rx);
    return(-1);
  }

  /* Now send the 's' command */
  result = fputc('s', tx);
  if(result < 0){
    perror(" Send the s command ");
    fclose(tx);
    fclose(rx);
    return(-1);
  }
  fflush(tx);

  /* Now read the response */
  result = fscanf(rx, "%s\n", temp[0]);

  /* Now get the number of following records */

  result = fscanf(rx, "%d\n", &numRecs);
  sprintf(line, "Fetching %d records", numRecs);
  fl_set_object_label(fd_testgui->serverInfo, line);

  listHead = flushEntryList(listHead);

  for(i=0;i<numRecs;i++){
    station = malloc(sizeof (struct stationData));
  
    fgets(station->call, MAXCALL, rx);
    station->call[strlen(station->call)-1] = 0x00;
    fgets(station->data, MAXDATA, rx);
    station->data[strlen(station->data)-1] = 0x00;
    fgets(station->id, MAXID, rx);
    station->id[strlen(station->id)-1] = 0x00;
    fgets(station->ip, MAXIP, rx);
    station->ip[strlen(station->ip)-1] = 0x00;

    if(strstr(station->call, "-R"))
      entryPtrs[0] = addEntryList(entryPtrs[0], station);
    else if(strstr(station->call, "-L"))
      entryPtrs[1] = addEntryList(entryPtrs[1], station);
    else if(strstr(station->call, "*"))
      entryPtrs[3] = addEntryList(entryPtrs[3], station);
    else if((station->call[0]) == ' ')
      entryPtrs[4] = addEntryList(entryPtrs[4], station);
     else 
       entryPtrs[2] = addEntryList(entryPtrs[2], station);
  }

  fclose(tx);
  fclose(rx);

  listHead = NULL;
  i = 0;

  while((listHead == NULL) &&
	(i < 5)){
    if(i < 5){
      if(entryPtrs[i] != NULL){
	listHead = entryPtrs[i];
	i++;
      }
      else
	i++;
    }
  }

  if(listHead){
    while(i<5){
      if(entryPtrs[i]){
	last = findEnd(listHead);
	last->next = entryPtrs[i];
      }
      i++;
    }
  }
}

/******** Flush entry list *************/

struct entry *flushEntryList(struct entry *list){

  struct entry  *temp;
  int           counter;

  if(list == NULL)
    return(0);

  counter = 0;
  do{
    counter++;
    temp = list->next;
    if(list->station != NULL)
      free(list->station);
    free(list);
    list = temp;
  }while(list != NULL);
  return(NULL);
}

/******* Add to entry list ***********/

struct entry *addEntryList(struct entry *list, struct stationData *station){

  struct entry  *next, *previous, *temp, *present;
  int           result;

  if(list == NULL){
    list = malloc(sizeof (struct entry));
    if(list != NULL){
      list->station = station;
      list->next = NULL;
    }
    return list;
  }

  present = previous = list;

  while(1){
    result = strcmp(station->call, (present->station)->call);
    if(result > 0){
      if(present->next == NULL){
	present->next = malloc(sizeof(struct entry));
	(present->next)->next = NULL;
	(present->next)->station = station;
	return(list);
      }
      else {
	previous = present;
	present = present->next;
      }
    } else if(result < 0){
      temp = malloc(sizeof(struct entry));
      temp->station = station;
      temp->next = present;
      if(previous != present){
	previous->next = temp;
	return(list);
      }
      else
	return(temp);
    } else if(result == 0)
      return(list);
  }

}

/********* Print the list of pointers *****/

struct entry printPointers(struct entry *list){

  struct entry  *temp;

  temp = list;

  do{
    printf("Pointer = %p.\n", temp);
    temp = temp->next;
  }while(temp != NULL);

}

/*********** Print stations list **********/

int printList(struct entry *list){

  int counter;
  char line[132], c;

  counter = 0;
  while(list != NULL){
    sprintf(line, "%-9s%-39s%6s %s", (list->station)->call,
	    (list->station)->data, (list->station)->id, (list->station)->ip);
    list = list->next;
    puts(line);
    counter++;
  }

  return(counter);
}








